commit:     ba6d20d101e079eb1e997fcfb830b40b111b7217
Author:     Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Tue Dec 22 09:52:43 2020 +0000
Commit:     Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Tue Dec 22 10:10:10 2020 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ba6d20d1

dev-python/pycryptodome: Unbundle libtomcrypt

Closes: https://bugs.gentoo.org/732662
Signed-off-by: Michał Górny <mgorny <AT> gentoo.org>

 .../pycryptodome-3.9.9-system-libtomcrypt.patch    | 43 +++++++++++++++++
 .../pycryptodome/pycryptodome-3.9.9-r1.ebuild      | 54 ++++++++++++++++++++++
 2 files changed, 97 insertions(+)

diff --git 
a/dev-python/pycryptodome/files/pycryptodome-3.9.9-system-libtomcrypt.patch 
b/dev-python/pycryptodome/files/pycryptodome-3.9.9-system-libtomcrypt.patch
new file mode 100644
index 00000000000..927ad65e7c4
--- /dev/null
+++ b/dev-python/pycryptodome/files/pycryptodome-3.9.9-system-libtomcrypt.patch
@@ -0,0 +1,43 @@
+--- a/setup.py 2019-01-19 22:52:55.000000000 +0100
++++ b/setup.py 2019-02-15 15:29:46.960976879 +0100
+@@ -367,11 +367,13 @@ ext_modules = [
+         include_dirs=['src/'],
+         sources=["src/CAST.c"]),
+     Extension("Crypto.Cipher._raw_des",
+-        include_dirs=['src/', 'src/libtom/'],
+-        sources=["src/DES.c"]),
++        include_dirs=['src/'],
++        sources=["src/DES.c"],
++        extra_link_args=["-ltomcrypt"]),
+     Extension("Crypto.Cipher._raw_des3",
+-        include_dirs=['src/', 'src/libtom/'],
+-        sources=["src/DES3.c"]),
++        include_dirs=['src/'],
++        sources=["src/DES3.c"],
++        extra_link_args=["-ltomcrypt"]),
+     Extension("Crypto.Util._cpuid_c",
+         include_dirs=['src/'],
+         sources=['src/cpuid.c']),
+@@ -400,8 +402,9 @@ ext_modules = [
+         include_dirs=['src/'],
+         sources=["src/ARC4.c"]),
+     Extension("Crypto.Cipher._Salsa20",
+-        include_dirs=['src/', 'src/libtom/'],
+-        sources=["src/Salsa20.c"]),
++        include_dirs=['src/'],
++        sources=["src/Salsa20.c"],
++        extra_link_args=["-ltomcrypt"]),
+     Extension("Crypto.Cipher._chacha20",
+         include_dirs=['src/'],
+         sources=["src/chacha20.c"]),
+--- a/src/DES.c        2019-01-19 22:52:55.000000000 +0100
++++ b/src/DES.c        2019-02-15 15:30:27.014967034 +0100
+@@ -39,7 +39,7 @@ FAKE_INIT(raw_des3)
+ 
+ /* Include the actial DES implementation */
+ #define LTC_NO_PROTOTYPES
+-#include "libtom/tomcrypt_des.c"
++#include <tomcrypt.h>
+ 
+ struct block_state {
+     symmetric_key sk;

diff --git a/dev-python/pycryptodome/pycryptodome-3.9.9-r1.ebuild 
b/dev-python/pycryptodome/pycryptodome-3.9.9-r1.ebuild
new file mode 100644
index 00000000000..8366e337747
--- /dev/null
+++ b/dev-python/pycryptodome/pycryptodome-3.9.9-r1.ebuild
@@ -0,0 +1,54 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{6..9} pypy3 )
+PYTHON_REQ_USE="threads(+)"
+
+inherit distutils-r1
+
+DESCRIPTION="A self-contained cryptographic library for Python"
+HOMEPAGE="https://www.pycryptodome.org/
+       https://github.com/Legrandin/pycryptodome/
+       https://pypi.org/project/pycryptodome/";
+SRC_URI="
+       https://github.com/Legrandin/pycryptodome/archive/v${PV}.tar.gz
+               -> ${P}.tar.gz"
+
+LICENSE="BSD-2 Unlicense"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE=""
+
+DEPEND="
+       dev-libs/gmp:0=
+       >=dev-libs/libtomcrypt-1.18.2-r1:="
+BDEPEND="
+       virtual/python-cffi[${PYTHON_USEDEP}]"
+RDEPEND="
+       ${DEPEND}
+       ${BDEPEND}
+       !dev-python/pycrypto"
+
+PATCHES=(
+       "${FILESDIR}/pycryptodome-3.9.4-parallel-make.patch"
+       "${FILESDIR}/pycryptodome-3.9.9-system-libtomcrypt.patch"
+)
+
+distutils_enable_tests setup.py
+
+python_prepare_all() {
+       # parallel make fixes
+       #  Multiple targets were compiling the same file, setuptools doesn't
+       #  understand this and you get race conditions where a file gets
+       #  overwritten while it's linking. This makes the files look like 
separate
+       #  files so this race won't happen
+       ln src/blowfish.c src/blowfish_eks.c || die
+       ln src/mont.c src/mont_math.c || die
+
+       # make sure we're unbundling it correctly
+       rm -r src/libtom || die
+
+       distutils-r1_python_prepare_all
+}

Reply via email to